
var socket = io('/escenario');
var a = 0;
//var x, y;

let video;
let poseNet;
let poses = [];

let x = [];
let y = [];
let v = [];
let t = []; // tipo de item a dibujar 
let NUM_BOLAS = 5; // numero de items que caen simultáneamente

let xPal=0, yPal=0;
let lastPal = -1;

let font;
let items = [];  // las imágenes de los ítems que caen
//let itemActual = 0;
let puntosLeft = 0;
let puntosRight = 0;
let puntosParaGanar = 5;
let winner = "";
let estado = "inicio";  // inicio, juego, winner
let puntoDivision = 0; // columna que divide la pantalla en dos
let audioIntro, audioInGame;
let pixelesPorShake = 3; // número de píxeles que se nueve la frontera (en un sentido u otro) cada vez que se recibe desde un móvil un evento de shake
let contBonusLeft = 0;
let contBonusRight = 0;
let limiteBonus = 25;
let numPuntosBonus = 3; // puntos que se obtienen al conseguir un bonus (llenar barra de bonus, que se hace metiendo bolas en las cajas con sensores


// este es el buffer que uso para dibujar los vídeos reducidos (incluido el de la webcam)
// y después pintarlos más grandes en el canvas
let graphics;
// este es el factor de escalado por el que reduzco los vídeos (incluido el de la webcam)
// para optimizar el procesamiento de todo. A la inversa, lo tengo en cuenta para reescalar
// las coordenadas de las partes del esqueleto cuando he de detectar colisiones con objetos
// que caen (pq los objetos que caen están a la escala original, la del canvas)
let escalado = 3;

let fondo;
let panchito;
let mccloud;
let valla;

function preload() {
//  audioIntro = loadSound("https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2FIntro2.mp3?1548525375178");
//  audioInGame = loadSound("https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2FIn_Game.mp3?1548523956198");  
	//careta = loadImage('../../assets/calabazaMini.png');
  items[0] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2FGorro%20Mexican.png?1548584054017');
  items[1] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2FGorro%20Americano.png?1548584053984');
  items[2] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2Fpelota.png?1548584714792');  


  items[3] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2Fmaracas.png?1548584054092');  
  items[4] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2FHamburger.png?1548584054223');  
  items[5] = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2Fcactus.png?1548584229145');  
  
  // esta va bien y además tiene varios tipos
	//font = loadFont('../../assets/mrsmonsteracad.ttf');
  font = loadFont('https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2Fmrsmonsteracad.ttf?1548485928116');
  fondo = loadImage('https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2F5463.jpg?1548517058887');
  panchito = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2Fpanchito.png?1548580970889');
  mccloud = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2FMcCloud.png?1548580970911');
  
  valla = loadImage('https://cdn.glitch.com/9780a46b-2f10-4e0a-92c9-dde534123a73%2Fvalla_alta.png?1548585039332');
}


function setup(){
  audioIntro = loadSound("https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2FIntro2.mp3?1548525375178");
  audioInGame = loadSound("https://cdn.glitch.com/a9f8d7ee-d2f6-4515-b9ea-d60d4cf2d387%2FIn_Game.mp3?1548523956198");  
  
  createCanvas(windowWidth,windowHeight);
  
  // pruebo esto para deshabilitar el refresh al mover el dedo hacia abajo
	$("html").css({
		"touch-action": "pan-down"
	});	  
  
  
  socket.on('connect', function() {
    var sessionid = socket.id;
    console.log("socket.id: " + sessionid);
  });


  socket.on('shakenRojo', function(data){ 
    if (estado === "juego") {
      puntoDivision = max(puntoDivision + pixelesPorShake, 0);    
    }
	})

  socket.on('shakenAzul', function(data){ 
    if (estado === "juego") {
      puntoDivision = min(puntoDivision - pixelesPorShake, width);
    }
	})

    

 

	graphics = createGraphics(width/escalado, height/escalado);
  video = createCapture(VIDEO);
  video.size(width/escalado, height/escalado);

  // Create a new poseNet method with a single detection
  poseNet = ml5.poseNet(video,
    {
     flipHorizontal: true,
      imageScaleFactor: 0.2
   },
    modelReady);
  
  // This sets up an event that fills the global variable "poses"
  // with an array every time new poses are detected
  poseNet.on('pose', function(results) {
    poses = results;
  });
  
  // Hide the video element, and just show the canvas
  video.hide();

  for (let i=0; i<NUM_BOLAS; i++) {
    x.push(random(width));
    y.push(random(-(height+50), -50));
    v.push(random(1, 17));
    t.push(round(random(0, items.length-1)));
  }

	textFont(font);
	// interesa que esté centrado, para que al crecer/decrecer aleatoriamente,
	// lo haga con respecto al centro y quede bien
	textAlign(CENTER, CENTER);

	puntoDivision = width/2;

  if (audioIntro.isLoaded()) {
    audioIntro.play();
  }

  
}




function modelReady() {
  //select('#status').html('Model Loaded');
}



function draw(){
  
  if (estado === "inicio") {
    pantallaInicio();
    if (audioIntro.isLoaded() && !audioIntro.isPlaying() ) { // .isPlaying() returns a boolean
      audioIntro.play();
    } 
  } else if (estado === "juego") {
    muestraEscenarioEnJuego();
    muestraValla();
    drawBolas();
    updateBolas();
    drawNarices();
    chequeaColisiones();
    muestraPuntuaciones();
    muestraBarrasBonus();
    chequeaGanador();
  } else if (estado === "winner") {
    pantallaWinner();
  } 
}


function muestraValla() {
  //image(valla,puntoDivision-valla.width/2, 0, valla.width, height);
}

function muestraBarrasBonus() {
  fill(0,255,0, 100);
  rect(20,20,map(contBonusLeft, 0, limiteBonus, 0, 200),50);
  rect(width-220,20,map(contBonusRight, 0, limiteBonus, 0, 200),50);
  
  noFill();
  stroke(255, 100);
  strokeWeight(5);
  rect(20,20,200,50);
  rect(width-220,20,200,50);
  
  noStroke();
}

function muestraEscenarioEnJuego() {
  graphics.fill(255);
	graphics.rect(0,0,graphics.width,graphics.height);

  graphics.image(fondo, 0, 0, graphics.width,graphics.height);

  graphics.image(valla,(puntoDivision-valla.width/2)/escalado, 0, (valla.width) / escalado, graphics.height);
  
  graphics.push();
  graphics.translate(video.width,0);
  graphics.scale(-1.0,1.0);
//  graphics.blend(video, 0, 0, video.width, video.height, 0, 0, graphics.width, graphics.height, DARKEST);
  graphics.blend(video, 0, 0, video.width, video.height, 0, 0, graphics.width, graphics.height, MULTIPLY    );
  graphics.pop();

  /*
	graphics.fill(255, 100, 100, 120);
 	graphics.rect(0,0,puntoDivision / escalado,graphics.height);
	graphics.fill(100, 100, 255, 120);
	graphics.rect(puntoDivision / escalado,0,graphics.width- puntoDivision / escalado,graphics.height);
*/
	image(graphics, 0, 0, width, height);

  //image(valla,puntoDivision-valla.width/2, 0, valla.width, height);
  
  fill(255, 100, 100, 120);
 	rect(0,0,puntoDivision, height);
	fill(100, 100, 255, 120);
	rect(puntoDivision,0,width- puntoDivision,height);
  
}


function pantallaInicio() {

  graphics.fill(255);
	graphics.rect(0,0,graphics.width,graphics.height);
  graphics.image(fondo, 0, 0, graphics.width,graphics.height);
	image(graphics, 0, 0, width, height);
  image(valla, width/2-valla.width/2, 0, valla.width, height);
  imageMode(CENTER);
  image(panchito, width/3, 3*height/4);
  image(mccloud, 2*width/3, 3*height/4);
  imageMode(CORNER);

  
  noStroke();
	textSize(200);
	fill(255,0,0,150);
	text("Homes' frontier", width/2, height/5);
	textSize(100)
  fill(255,200);
	text("Pulsa una tecla para comenzar!", width/2, height-100);

}


function pantallaWinner() {
  graphics.fill(255);
	graphics.rect(0,0,graphics.width,graphics.height);
  graphics.image(fondo, 0, 0, graphics.width,graphics.height);
	image(graphics, 0, 0, width, height);

	textSize(100);
	fill(255,150);
  if (winner === "left") {
    imageMode(CENTER);
    image(panchito, width/3, 3*height/4);
    imageMode(CORNER);
    fill(255,0,0,150);
	  text("Óooooorale, essse Panchito chidón!!", width/2, height/5);
  } else if (winner === "right") {
	  imageMode(CENTER);
    image(mccloud, width/3, 2*height/3);
    imageMode(CORNER);
    fill(255,0,0,150);
    text("Esto es mío... forastero!", width/2, height/5);    
  } else if (winner === "both") {
	  imageMode(CENTER);
    image(panchito, width/2, 3*height/4);
    image(mccloud, width/4, 2*height/3);
    imageMode(CORNER);
    text("En seeeerio??!!! empaaaate??!!", width/2, height/4);
  }
	//text(puntosLeft, 100, 100);
	//text(puntosRight, width-100, 100);
}


function muestraPuntuaciones() {
	strokeWeight(10);
	stroke(250, 100);
	//line(puntoDivision, 0, puntoDivision, height);
	strokeWeight(1);
	noStroke();
	textSize(120);
	fill(255,150);
	text(puntosLeft, 100, 120);
	text(puntosRight, width-100, 120);

}

function chequeaGanador() {
  if (puntosLeft >= puntosParaGanar && puntosRight < puntosParaGanar) {
    winner = "left";
    estado = "winner";
    audioInGame.stop();
    audioIntro.play();
    socket.emit('winner', {winner: "rojo"});
  } else if (puntosLeft < puntosParaGanar && puntosRight >= puntosParaGanar) {
    winner = "right";
    estado = "winner";
    audioInGame.stop();
    audioIntro.play();
    socket.emit('winner', {winner: "azul"});
  } else if (puntosLeft >= puntosParaGanar && puntosRight >= puntosParaGanar) {
    winner = "both";
    estado = "winner";
    audioInGame.stop();
    audioIntro.play();
  }

}



function updateBolas()  {
  for (let i=0; i<NUM_BOLAS; i++) {
    y[i] = y[i] + v[i];
    if (y[i] > (height+50)) {
      y[i] = -50;
			x[i] = random(width);
    }
  }
}


function drawBolas()  {
  for (let i=0; i<NUM_BOLAS; i++) {
		blend(items[t[i]], 0, 0, items[t[i]].width, items[t[i]].height, x[i]-100, y[i]-100, 150, 150, LIGHTEST);
  }
}



function drawNarices()  {
  for (let i = 0; i < poses.length; i++) {
    // For each pose detected, draw the wings
    let pose = poses[i].pose;
    //fill(0,200,200,100);
    noStroke();
    // una bola en la nariz
		fill(255,0,0,170);
		ellipse(escalado * pose.keypoints[0].position.x, escalado * pose.keypoints[0].position.y, 100, 100);
	}
}


function chequeaColisiones()  {
	for (let j = 0; j < poses.length; j++) {
    let pose = poses[j].pose;
		for (let i=0; i<NUM_BOLAS; i++) {
			//console.log(dist(pose.keypoints[0].position.x, pose.keypoints[0].position.y, x[i], y[i]));
			if (dist(escalado * pose.keypoints[0].position.x, escalado * pose.keypoints[0].position.y, x[i], y[i]) < 150) {
					y[i] = -50;
					x[i] = random(width);
          t[i] = round(random(0, items.length-1));
					if (escalado * pose.keypoints[0].position.x < puntoDivision) {
						puntosLeft++;
					} else {
						puntosRight++;
					}
			}
		}
	}
}



function keyTyped() {
  console.log(keyCode);
  if (estado === "inicio") {
    estado = "juego";
    audioIntro.stop();
    audioInGame.play();
  } else if (estado === "winner") {
    estado = "inicio";
    puntosLeft = 0;
    puntosRight = 0;    
 	  puntoDivision = width/2;       
    contBonusLeft = 0;
    contBonusRight = 0;
  } else if (estado === "juego") {
    if (key === "x") {
      estado = "inicio";
      audioInGame.stop();
      audioIntro.play();
      puntosLeft = 0;
      puntosRight = 0;    
 	    puntoDivision = width/2;       
      contBonusLeft = 0;
      contBonusRight = 0;
    } else if (key === 'a') {
      puntoDivision = max(puntoDivision-10, 0);
    } else if (key === 's') {
      puntoDivision = min(puntoDivision+10, width);
    }
  }
}


// lectura del gamepad, asociada a la entrada de los sensores
function updateStatus() {
    window.requestAnimationFrame(updateStatus);
  		//console.log(navigator.getGamepads());
      for (var padindex = 0; padindex < 4; ++padindex) {
          var pad = navigator.getGamepads()[padindex];
          if (pad) {
            if (pad.buttons[0].pressed) {
              //puntoDivision = max(puntoDivision+10, 0);
              contBonusRight++;
              if (contBonusRight > limiteBonus) {
                contBonusRight = 0;
                // accion de bonus para right
                puntosRight += numPuntosBonus;
              } 
            }
            if (pad.buttons[1].pressed) {
              //puntoDivision = max(puntoDivision-10, 0);
              contBonusLeft++;
              if (contBonusLeft > limiteBonus) {
                contBonusLeft = 0;
                // accion de bonus para left       
                puntosLeft += numPuntosBonus; 
              }              
            }
          }
      }
}
//console.log(navigator.getGamepads());
window.requestAnimationFrame(updateStatus);



function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
}
