var express = require('express'); 
var app = express();
var server = app.listen(process.env.PORT);
app.use(express.static('public'));
console.log('server running')

// el namespace por defecto, es el que usarán los móviles
var socket = require('socket.io');
var io = socket(server);
io.sockets.on('connection', newConnection);


// un namespace para las conexiones que van a mostrar el escenario
var escenario = io.of('/escenario');
escenario.on('connection', newConnectionEscenario);



// un namespace para las conexiones que llegan desde el equipo rojo
var rojo = io.of('/rojo');
rojo.on('connection', newConnectionRojo);

// un namespace para las conexiones que llegan desde el equipo azul
var azul = io.of('/azul');
azul.on('connection', newConnectionAzul);


function newConnectionEscenario(socket){
	console.log('new connection: ' + socket.id)
  socket.on('winner',notificaWinner);
  
  function notificaWinner(data){
    console.log("winner");
    if (data.winner === "rojo") {
      
      //  rojo.emit('moveUp', data); // send to everyone except the sender
      io.of('/rojo').emit('win', 'win');
      io.of('/azul').emit('looser', 'looser');
    } else if (data.winner === "azul") {
      //  escenario.emit('moveUp', data); // send to everyone except the sender
      io.of('/azul').emit('win', 'win');
      io.of('/rojo').emit('looser', 'looser');
    }
    
  }
}


function newConnection(socket){
	console.log('new connection: ' + socket.id)
  socket.on('moveUp',moveUp);
  socket.on('moveDown',moveDown);
  socket.on('shaken',shaken);

  function moveUp(data){
    console.log("move up");
    escenario.emit('moveUp', data); // send to everyone except the sender
  }

  function moveDown(data){
    console.log("move down");
    escenario.emit('moveDown', data); // send to everyone except the sender
  }

  function shaken(data){
    console.log("shaken");
    escenario.emit('shaken', data); // send to everyone except the sender
  }

}

function newConnectionRojo(socket){
	console.log('new connection: ' + socket.id)
  socket.on('shaken',shaken);

  function shaken(data){
    console.log("shaken");
    escenario.emit('shakenRojo', data); // send to everyone except the sender
  }

}

function newConnectionAzul(socket){
	console.log('new connection: ' + socket.id)
  socket.on('shaken',shaken);

  function shaken(data){
    console.log("shaken");
    escenario.emit('shakenAzul', {num: -1 * data.num}); // send to everyone except the sender
  }

}